# Class BOption

Option represents a name-value pair, either directly configurable by the user or some system property.

#### Hierarchy (View Summary)

- AbstractBeccaEntity < BOption >
  - BOption

- Defined in src/becca/entities/boption.ts:10

##### Index

### Constructors

constructor

### Properties

blobId?
dateCreated?
dateModified?
isProtected?
isSynced?
name
utcDateCreated
utcDateModified?
value

### Accessors

becca
isDeleted
entityName
hashedProperties
primaryKeyName

### Methods

_getContent
_setContent
beforeSaving
generateHash
getPojo
getPojoToSave
getUtcDateChanged
hasStringContent
init
markAsDeleted
markAsDeletedSimple
putEntityChange
save
updateFromRow

## Constructors

### constructor

- new BOption(row?: OptionRow ): BOption

  #### Parameters

  - `Optional` row: OptionRow

  #### Returns BOption

  Overrides AbstractBeccaEntity.constructor

  - Defined in src/becca/entities/boption.ts:24

## Properties

### `Optional` blobId

blobId?: string

Inherited from AbstractBeccaEntity.blobId

- Defined in src/becca/entities/abstract_becca_entity.ts:34

### `Optional` dateCreated

dateCreated?: string

Inherited from AbstractBeccaEntity.dateCreated

- Defined in src/becca/entities/abstract_becca_entity.ts:27

### `Optional` dateModified

dateModified?: string

Inherited from AbstractBeccaEntity.dateModified

- Defined in src/becca/entities/abstract_becca_entity.ts:28

### `Optional` isProtected

isProtected?: boolean

Inherited from AbstractBeccaEntity.isProtected

- Defined in src/becca/entities/abstract_becca_entity.ts:32

### `Optional` isSynced

isSynced?: boolean

Inherited from AbstractBeccaEntity.isSynced

- Defined in src/becca/entities/abstract_becca_entity.ts:33

### name

name: string

- Defined in src/becca/entities/boption.ts:21

### utcDateCreated

utcDateCreated: string

Inherited from AbstractBeccaEntity.utcDateCreated

- Defined in src/becca/entities/abstract_becca_entity.ts:30

### `Optional` utcDateModified

utcDateModified?: string

Inherited from AbstractBeccaEntity.utcDateModified

- Defined in src/becca/entities/abstract_becca_entity.ts:26

### value

value: string

- Defined in src/becca/entities/boption.ts:22

## Accessors

### `Protected` becca

- get becca(): default

  #### Returns default

  Inherited from AbstractBeccaEntity.becca

  - Defined in src/becca/entities/abstract_becca_entity.ts:47

### isDeleted

- get isDeleted(): boolean

  #### Returns boolean

  Inherited from AbstractBeccaEntity.isDeleted

  - Defined in src/becca/entities/abstract_becca_entity.ts:95

### `Static` entityName

- get entityName(): string

  #### Returns string

  - Defined in src/becca/entities/boption.ts:11

### `Static` hashedProperties

- get hashedProperties(): string[]

  #### Returns string[]

  - Defined in src/becca/entities/boption.ts:17

### `Static` primaryKeyName

- get primaryKeyName(): string

  #### Returns string

  - Defined in src/becca/entities/boption.ts:14

## Methods

### `Protected`_getContent

- _getContent(): string | Buffer< ArrayBufferLike >

  #### Returns string | Buffer< ArrayBufferLike >

  Inherited from AbstractBeccaEntity._getContent

  - Defined in src/becca/entities/abstract_becca_entity.ts:261

### `Protected`_setContent

- _setContent(content: string | Buffer< ArrayBufferLike >, opts?: ContentOpts ): void

  #### Parameters

  - content: string | Buffer< ArrayBufferLike >
  - opts: ContentOpts = {}

  #### Returns void

  Inherited from AbstractBeccaEntity._setContent

  - Defined in src/becca/entities/abstract_becca_entity.ts:140

### beforeSaving

- beforeSaving(): void

  #### Returns void

  Overrides AbstractBeccaEntity.beforeSaving

  - Defined in src/becca/entities/boption.ts:40

### generateHash

- generateHash(isDeleted?: boolean): string

  #### Parameters

  - `Optional` isDeleted: boolean

  #### Returns string

  Inherited from AbstractBeccaEntity.generateHash

  - Defined in src/becca/entities/abstract_becca_entity.ts:63

### getPojo

- getPojo(): {
  isSynced: undefined
  | boolean;
  name: string;
  utcDateModified: undefined | string;
  value: string;
  }

  #### Returns {
  isSynced: undefined | boolean;
  name: string;
  utcDateModified: undefined | string;
  value: string;
  }

  Overrides AbstractBeccaEntity.getPojo

  - Defined in src/becca/entities/boption.ts:46

### `Protected` getPojoToSave

- getPojoToSave(): {}

  #### Returns {}

  Inherited from AbstractBeccaEntity.getPojoToSave

  - Defined in src/becca/entities/abstract_becca_entity.ts:78

### getUtcDateChanged

- getUtcDateChanged(): string

  #### Returns string

  Inherited from AbstractBeccaEntity.getUtcDateChanged

  - Defined in src/becca/entities/abstract_becca_entity.ts:43

### hasStringContent

- hasStringContent(): boolean

  #### Returns boolean

  Inherited from AbstractBeccaEntity.hasStringContent

  - Defined in src/becca/entities/abstract_becca_entity.ts:82

### init

- init(): void

  #### Returns void

  Inherited from AbstractBeccaEntity.init

  - Defined in src/becca/entities/abstract_becca_entity.ts:89

### markAsDeleted

- markAsDeleted(deleteId?: null | string): void

  Mark the entity as (soft) deleted. It will be completely erased later.

  This is a low-level method, for notes and branches use `note.deleteNote()` and 'branch.deleteBranch()` instead.

  #### Parameters

  - deleteId: null | string = null

  #### Returns void

  Inherited from AbstractBeccaEntity.markAsDeleted

  - Defined in src/becca/entities/abstract_becca_entity.ts:277

### markAsDeletedSimple

- markAsDeletedSimple(): void

  #### Returns void

  Inherited from AbstractBeccaEntity.markAsDeletedSimple

  - Defined in src/becca/entities/abstract_becca_entity.ts:303

### `Protected` putEntityChange

- putEntityChange(isDeleted: boolean): void

  #### Parameters

  - isDeleted: boolean

  #### Returns void

  Inherited from AbstractBeccaEntity.putEntityChange

  - Defined in src/becca/entities/abstract_becca_entity.ts:51

### save

- save(opts?: {}): this

  Saves entity - executes SQL, but doesn't commit the transaction on its own

  #### Parameters

  - `Optional` opts: {}

  #### Returns this

  Inherited from AbstractBeccaEntity.save

  - Defined in src/becca/entities/abstract_becca_entity.ts:103

### updateFromRow

- updateFromRow(row: OptionRow ): void

  #### Parameters

  - row: OptionRow

  #### Returns void

  Overrides AbstractBeccaEntity.updateFromRow

  - Defined in src/becca/entities/boption.ts:33